
//=======================================================
//  This code is generated by Terasic System Builder
//=======================================================

module Laboratorio7(

	//////////// CLOCK //////////
	CLOCK_50,

	//////////// LED //////////
	LED,

	//////////// KEY //////////
	KEY,

	//////////// SW //////////
	SW,

	//////////// SDRAM //////////
	DRAM_ADDR,
	DRAM_BA,
	DRAM_CAS_N,
	DRAM_CKE,
	DRAM_CLK,
	DRAM_CS_N,
	DRAM_DQ,
	DRAM_DQM,
	DRAM_RAS_N,
	DRAM_WE_N,

	//////////// EPCS //////////
	EPCS_ASDO,
	EPCS_DATA0,
	EPCS_DCLK,
	EPCS_NCSO,

	//////////// Accelerometer and EEPROM //////////
	G_SENSOR_CS_N,
	G_SENSOR_INT,
	I2C_SCLK,
	I2C_SDAT,

	//////////// ADC //////////
	ADC_CS_N,
	ADC_SADDR,
	ADC_SCLK,
	ADC_SDAT,

	//////////// 2x13 GPIO Header //////////
	GPIO_2,
	GPIO_2_IN,

	//////////// GPIO_0, GPIO_0 connect to GPIO Default //////////
	GPIO,
	GPIO_IN,

	//////////// GPIO_1, GPIO_1 connect to GPIO Default //////////
	GPIO_B,
	GPIO_B_IN 
);

//=======================================================
//  PARAMETER declarations
//=======================================================


//=======================================================
//  PORT declarations
//=======================================================

//////////// CLOCK //////////
input 		          		CLOCK_50;

//////////// LED //////////
output		     [7:0]		LED;

//////////// KEY //////////
input 		     [1:0]		KEY;

//////////// SW //////////
input 		     [3:0]		SW;

//////////// SDRAM //////////
output		    [12:0]		DRAM_ADDR;
output		     [1:0]		DRAM_BA;
output		          		DRAM_CAS_N;
output		          		DRAM_CKE;
output		          		DRAM_CLK;
output		          		DRAM_CS_N;
inout 		    [15:0]		DRAM_DQ;
output		     [1:0]		DRAM_DQM;
output		          		DRAM_RAS_N;
output		          		DRAM_WE_N;

//////////// EPCS //////////
output		          		EPCS_ASDO;
input 		          		EPCS_DATA0;
output		          		EPCS_DCLK;
output		          		EPCS_NCSO;

//////////// Accelerometer and EEPROM //////////
output		          		G_SENSOR_CS_N;
input 		          		G_SENSOR_INT;
output		          		I2C_SCLK;
inout 		          		I2C_SDAT;

//////////// ADC //////////
output		          		ADC_CS_N;
output		          		ADC_SADDR;
output		          		ADC_SCLK;
input 		          		ADC_SDAT;

//////////// 2x13 GPIO Header //////////
inout 		    [12:0]		GPIO_2;
input 		     [2:0]		GPIO_2_IN;

//////////// GPIO_0, GPIO_0 connect to GPIO Default //////////
inout 		    [33:0]		GPIO;
input 		     [1:0]		GPIO_IN;

//////////// GPIO_1, GPIO_1 connect to GPIO Default //////////
inout 		    [33:0]		GPIO_B;
input 		     [1:0]		GPIO_B_IN;


//=======================================================
//  REG/WIRE declarations
//=======================================================




//=======================================================
//  Structural coding
//=======================================================
wire [10:0]CounterX;
wire [10:0]CounterY;


reg[3:0] lcd_r_out;
reg[3:0] lcd_g_out;
reg[3:0] lcd_b_out;

wire V_SYNC;
wire H_SYNC;
wire video_on;

assign GPIO[0]=lcd_r_out[3];
assign GPIO[1]=lcd_r_out[2];
assign GPIO[3]=lcd_r_out[1];
assign GPIO[5]=lcd_r_out[0];
assign GPIO[7]=lcd_g_out[3];
assign GPIO[9]=lcd_g_out[2];
assign GPIO[11]=lcd_g_out[1];
assign GPIO[13]=lcd_g_out[0];
assign GPIO[15]=lcd_b_out[3];
assign GPIO[17]=lcd_b_out[2];
assign GPIO[19]=lcd_b_out[1];
assign GPIO[21]=lcd_b_out[0];
assign GPIO[23]=~V_SYNC;
assign GPIO[25]=~H_SYNC;


reg [10:0]pos_x;
reg pos_x_flag =1'b0;
reg [10:0]pos_y;
reg pos_y_flag =1'b0;
wire frame =(CounterX==11'd639)&&(CounterY==11'd479);

wire clk_25mhz;
pll_25mhz pll_25mhz_inst
(
	.inclk0(CLOCK_50) ,	// input  inclk0_sig
	.c0(clk_25mhz) ,	// output  c0_sig
);

mi_vga mi_vga_inst
(
	.clk(clk_25mhz) ,	// input  clk_sig
	.h_sync(H_SYNC) ,	// output  h_sync_sig
	.v_sync(V_SYNC) ,	// output  v_sync_sig
	.video_on(video_on) ,	// output  video_on_sig
	.pixel_x(CounterX) ,	// output [N-1:0] pixel_x_sig
	.pixel_y(CounterY) 	// output [N-1:0] pixel_y_sig
);


////////////////////////////nube////////////////////////////////////////////////////////////////////




/*MUX DE VIDEO*/
always@(negedge clk_25mhz)
begin
	if(!video_on)
	begin
		lcd_r_out<=4'd0;
		lcd_g_out<=4'd0;
		lcd_b_out<=4'd0;
	end
	else
	begin
		lcd_r_out<=4'd0;
		lcd_g_out<=4'h9;
		lcd_b_out<=4'hF;
	end
end



endmodule
